Index: kernel/generic/src/synch/rcu.c
===================================================================
--- kernel/generic/src/synch/rcu.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/synch/rcu.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -957,8 +957,8 @@
 			
 			/* Wait for the GP to complete. */
-			errno_t ret = _condvar_wait_timeout_spinlock(&rcu.gp_ended, &rcu.gp_lock, 
+			int ret = _condvar_wait_timeout_spinlock(&rcu.gp_ended, &rcu.gp_lock, 
 				SYNCH_NO_TIMEOUT, SYNCH_FLAGS_INTERRUPTIBLE);
 			
-			if (ret == EINTR) {
+			if (ret == ESYNCH_INTERRUPTED) {
 				spinlock_unlock(&rcu.gp_lock);
 				return false;			
@@ -1013,10 +1013,10 @@
 		spinlock_lock(&rcu.gp_lock);
 
-		errno_t ret = 0;
+		int ret = 0;
 		ret = _condvar_wait_timeout_spinlock(&rcu.expedite_now, &rcu.gp_lock,
 			DETECT_SLEEP_MS * 1000, SYNCH_FLAGS_INTERRUPTIBLE);
 
 		/* rcu.expedite_now was signaled. */
-		if (ret == EOK) {
+		if (ret == ESYNCH_OK_BLOCKED) {
 			*expedite = true;
 		}
@@ -1024,5 +1024,5 @@
 		spinlock_unlock(&rcu.gp_lock);
 
-		return (ret != EINTR);
+		return (ret != ESYNCH_INTERRUPTED);
 	}
 }
@@ -1271,5 +1271,5 @@
 		int ret = _condvar_wait_timeout_spinlock(&rcu.gp_ended, &rcu.gp_lock, 
 			SYNCH_NO_TIMEOUT, SYNCH_FLAGS_INTERRUPTIBLE);
-		interrupted = (ret == EINTR);
+		interrupted = (ret == ESYNCH_INTERRUPTED);
 	}
 	
@@ -1332,5 +1332,5 @@
 			&rcu.gp_lock, SYNCH_NO_TIMEOUT, SYNCH_FLAGS_INTERRUPTIBLE);
 		
-		interrupted = (ret == EINTR);
+		interrupted = (ret == ESYNCH_INTERRUPTED);
 	}
 	
@@ -1406,5 +1406,5 @@
 	spinlock_unlock(&rcu.gp_lock);
 	
-	return (ret != EINTR);
+	return (ret != ESYNCH_INTERRUPTED);
 }
 
Index: kernel/generic/src/synch/semaphore.c
===================================================================
--- kernel/generic/src/synch/semaphore.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/synch/semaphore.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -71,7 +71,7 @@
  *
  */
-errno_t _semaphore_down_timeout(semaphore_t *sem, uint32_t usec, unsigned int flags)
+int _semaphore_down_timeout(semaphore_t *sem, uint32_t usec, unsigned int flags)
 {
-	return waitq_sleep_timeout(&sem->wq, usec, flags, NULL);
+	return waitq_sleep_timeout(&sem->wq, usec, flags);
 }
 
Index: kernel/generic/src/synch/smc.c
===================================================================
--- kernel/generic/src/synch/smc.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/synch/smc.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -43,5 +43,5 @@
 #include <mm/as.h>
 
-sys_errno_t sys_smc_coherence(uintptr_t va, size_t size)
+sysarg_t sys_smc_coherence(uintptr_t va, size_t size)
 {
 	if (overlaps(va, size, (uintptr_t) NULL, PAGE_SIZE))
Index: kernel/generic/src/synch/smp_memory_barrier.c
===================================================================
--- kernel/generic/src/synch/smp_memory_barrier.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/synch/smp_memory_barrier.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -51,5 +51,5 @@
  * @return Irrelevant.
  */
-sys_errno_t sys_smp_memory_barrier(void)
+sysarg_t sys_smp_memory_barrier(void)
 {
 	for (unsigned int cpu_id = 0; cpu_id < config.cpu_active; ++cpu_id) {
Index: kernel/generic/src/synch/spinlock.c
===================================================================
--- kernel/generic/src/synch/spinlock.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/synch/spinlock.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -153,8 +153,8 @@
  *
  */
-bool spinlock_trylock(spinlock_t *lock)
+int spinlock_trylock(spinlock_t *lock)
 {
 	preemption_disable();
-	bool ret = !test_and_set(&lock->val);
+	int rc = !test_and_set(&lock->val);
 	
 	/*
@@ -163,8 +163,8 @@
 	CS_ENTER_BARRIER();
 	
-	if (!ret)
+	if (!rc)
 		preemption_enable();
 	
-	return ret;
+	return rc;
 }
 
@@ -257,11 +257,11 @@
  *
  */
-bool irq_spinlock_trylock(irq_spinlock_t *lock)
+int irq_spinlock_trylock(irq_spinlock_t *lock)
 {
 	ASSERT_IRQ_SPINLOCK(interrupts_disabled(), lock);
-	bool ret = spinlock_trylock(&(lock->lock));
-	
-	ASSERT_IRQ_SPINLOCK((!ret) || (!lock->guard), lock);
-	return ret;
+	int rc = spinlock_trylock(&(lock->lock));
+	
+	ASSERT_IRQ_SPINLOCK((!rc) || (!lock->guard), lock);
+	return rc;
 }
 
Index: kernel/generic/src/synch/waitq.c
===================================================================
--- kernel/generic/src/synch/waitq.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/synch/waitq.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -45,5 +45,4 @@
 
 #include <assert.h>
-#include <errno.h>
 #include <synch/waitq.h>
 #include <synch/spinlock.h>
@@ -239,8 +238,4 @@
  * @param flags Specify mode of the sleep.
  *
- * @param[out] blocked  On return, regardless of the return code,
- *                      `*blocked` is set to `true` iff the thread went to
- *                      sleep.
- *
  * The sleep can be interrupted only if the
  * SYNCH_FLAGS_INTERRUPTIBLE bit is specified in flags.
@@ -256,28 +251,23 @@
  * call will immediately return, reporting either success or failure.
  *
- * @return EAGAIN, meaning that the sleep failed because it was requested
- *                 as SYNCH_FLAGS_NON_BLOCKING, but there was no pending wakeup.
- * @return ETIMEOUT, meaning that the sleep timed out.
- * @return EINTR, meaning that somebody interrupted the sleeping
- *         thread. Check the value of `*blocked` to see if the thread slept,
- *         or if a pending interrupt forced it to return immediately.
- * @return EOK, meaning that none of the above conditions occured, and the
- *              thread was woken up successfuly by `waitq_wakeup()`. Check
- *              the value of `*blocked` to see if the thread slept or if
- *              the wakeup was already pending.
- *
- */
-errno_t waitq_sleep_timeout(waitq_t *wq, uint32_t usec, unsigned int flags, bool *blocked)
+ * @return ESYNCH_WOULD_BLOCK, meaning that the sleep failed because at the
+ *         time of the call there was no pending wakeup
+ * @return ESYNCH_TIMEOUT, meaning that the sleep timed out.
+ * @return ESYNCH_INTERRUPTED, meaning that somebody interrupted the sleeping
+ *         thread.
+ * @return ESYNCH_OK_ATOMIC, meaning that the sleep succeeded and that there
+ *         was a pending wakeup at the time of the call. The caller was not put
+ *         asleep at all.
+ * @return ESYNCH_OK_BLOCKED, meaning that the sleep succeeded; the full sleep
+ *         was attempted.
+ *
+ */
+int waitq_sleep_timeout(waitq_t *wq, uint32_t usec, unsigned int flags)
 {
 	assert((!PREEMPTION_DISABLED) || (PARAM_NON_BLOCKING(flags, usec)));
 	
 	ipl_t ipl = waitq_sleep_prepare(wq);
-	bool nblocked;
-	errno_t rc = waitq_sleep_timeout_unsafe(wq, usec, flags, &nblocked);
-	waitq_sleep_finish(wq, nblocked, ipl);
-
-	if (blocked != NULL) {
-		*blocked = nblocked;
-	}
+	int rc = waitq_sleep_timeout_unsafe(wq, usec, flags);
+	waitq_sleep_finish(wq, rc, ipl);
 	return rc;
 }
@@ -330,27 +320,32 @@
  * lock is released.
  *
- * @param wq       Wait queue.
- * @param blocked  Out parameter of waitq_sleep_timeout_unsafe().
- * @param ipl      Interrupt level returned by waitq_sleep_prepare().
- *
- */
-void waitq_sleep_finish(waitq_t *wq, bool blocked, ipl_t ipl)
-{
-	if (blocked) {
-		/*
+ * @param wq  Wait queue.
+ * @param rc  Return code of waitq_sleep_timeout_unsafe().
+ * @param ipl Interrupt level returned by waitq_sleep_prepare().
+ *
+ */
+void waitq_sleep_finish(waitq_t *wq, int rc, ipl_t ipl)
+{
+	switch (rc) {
+	case ESYNCH_WOULD_BLOCK:
+	case ESYNCH_OK_ATOMIC:
+		irq_spinlock_unlock(&wq->lock, false);
+		break;
+	default:
+		/* 
 		 * Wait for a waitq_wakeup() or waitq_unsleep() to complete
 		 * before returning from waitq_sleep() to the caller. Otherwise
 		 * the caller might expect that the wait queue is no longer used 
 		 * and deallocate it (although the wakeup on a another cpu has 
-		 * not yet completed and is using the wait queue).
-		 *
-		 * Note that we have to do this for EOK and EINTR, but not
-		 * necessarily for ETIMEOUT where the timeout handler stops
-		 * using the waitq before waking us up. To be on the safe side,
-		 * ensure the waitq is not in use anymore in this case as well.
+		 * not yet completed and is using the wait queue). 
+		 * 
+		 * Note that we have to do this for ESYNCH_OK_BLOCKED and
+		 * ESYNCH_INTERRUPTED, but not necessarily for ESYNCH_TIMEOUT
+		 * where the timeout handler stops using the waitq before waking 
+		 * us up. To be on the safe side, ensure the waitq is not in use 
+		 * anymore in this case as well.
 		 */
 		waitq_complete_wakeup(wq);
-	} else {
-		irq_spinlock_unlock(&wq->lock, false);
+		break;
 	}
 	
@@ -368,21 +363,17 @@
  * @param flags See waitq_sleep_timeout().
  *
- * @param[out] blocked  See waitq_sleep_timeout().
- *
  * @return See waitq_sleep_timeout().
  *
  */
-errno_t waitq_sleep_timeout_unsafe(waitq_t *wq, uint32_t usec, unsigned int flags, bool *blocked)
-{
-	*blocked = false;
-
+int waitq_sleep_timeout_unsafe(waitq_t *wq, uint32_t usec, unsigned int flags)
+{
 	/* Checks whether to go to sleep at all */
 	if (wq->missed_wakeups) {
 		wq->missed_wakeups--;
-		return EOK;
+		return ESYNCH_OK_ATOMIC;
 	} else {
 		if (PARAM_NON_BLOCKING(flags, usec)) {
 			/* Return immediately instead of going to sleep */
-			return EAGAIN;
+			return ESYNCH_WOULD_BLOCK;
 		}
 	}
@@ -401,5 +392,6 @@
 		if (THREAD->interrupted) {
 			irq_spinlock_unlock(&THREAD->lock, false);
-			return EINTR;
+			irq_spinlock_unlock(&wq->lock, false);
+			return ESYNCH_INTERRUPTED;
 		}
 		
@@ -413,5 +405,5 @@
 			THREAD->last_cycle = get_cycle();
 			irq_spinlock_unlock(&THREAD->lock, false);
-			return EINTR;
+			return ESYNCH_INTERRUPTED;
 		}
 	} else
@@ -424,5 +416,5 @@
 			THREAD->last_cycle = get_cycle();
 			irq_spinlock_unlock(&THREAD->lock, false);
-			return ETIMEOUT;
+			return ESYNCH_TIMEOUT;
 		}
 		
@@ -441,9 +433,4 @@
 	THREAD->sleep_queue = wq;
 	
-	/* Must be before entry to scheduler, because there are multiple
-	 * return vectors.
-	 */
-	*blocked = true;
-	
 	irq_spinlock_unlock(&THREAD->lock, false);
 	
@@ -451,5 +438,5 @@
 	scheduler();
 	
-	return EOK;
+	return ESYNCH_OK_BLOCKED;
 }
 
Index: kernel/generic/src/synch/workqueue.c
===================================================================
--- kernel/generic/src/synch/workqueue.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/synch/workqueue.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -38,5 +38,4 @@
 
 #include <assert.h>
-#include <errno.h>
 #include <synch/workqueue.h>
 #include <synch/spinlock.h>
@@ -257,5 +256,5 @@
  * workq_stop().
  */
-bool workq_init(struct work_queue *workq, const char *name)
+int workq_init(struct work_queue *workq, const char *name)
 {
 	workq_preinit(workq, name);
@@ -395,5 +394,5 @@
  * See workq_enqueue_noblock() for more details.
  */
-bool workq_global_enqueue_noblock(work_t *work_item, work_func_t func)
+int workq_global_enqueue_noblock(work_t *work_item, work_func_t func)
 {
 	return workq_enqueue_noblock(&g_work_queue, work_item, func);
@@ -404,5 +403,5 @@
  * See workq_enqueue() for more details.
  */
-bool workq_global_enqueue(work_t *work_item, work_func_t func)
+int workq_global_enqueue(work_t *work_item, work_func_t func)
 {
 	return workq_enqueue(&g_work_queue, work_item, func);
@@ -427,5 +426,5 @@
  * @return true  Otherwise. func() will be invoked in a separate thread.
  */
-bool workq_enqueue_noblock(struct work_queue *workq, work_t *work_item, 
+int workq_enqueue_noblock(struct work_queue *workq, work_t *work_item, 
 	work_func_t func)
 {
@@ -447,5 +446,5 @@
  * @return true  Otherwise. func() will be invoked in a separate thread.
  */
-bool workq_enqueue(struct work_queue *workq, work_t *work_item, work_func_t func)
+int workq_enqueue(struct work_queue *workq, work_t *work_item, work_func_t func)
 {
 	return _workq_enqueue(workq, work_item, func, true);
@@ -895,8 +894,8 @@
 	
 	while (list_empty(&info->work_queues) && !stop) {
-		errno_t ret = _condvar_wait_timeout_irq_spinlock(&info->req_cv, 
+		int ret = _condvar_wait_timeout_irq_spinlock(&info->req_cv, 
 			&info->lock, SYNCH_NO_TIMEOUT, SYNCH_FLAGS_INTERRUPTIBLE);
 		
-		stop = (ret == EINTR);
+		stop = (ret == ESYNCH_INTERRUPTED);
 	}
 	
Index: kernel/generic/src/syscall/copy.c
===================================================================
--- kernel/generic/src/syscall/copy.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/syscall/copy.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -57,10 +57,10 @@
  * @param size Size of the data to be copied.
  *
- * @return EOK on success or an error code from @ref errno.h.
+ * @return EOK on success or error code from @ref errno.h.
  */
-errno_t copy_from_uspace(void *dst, const void *uspace_src, size_t size)
+int copy_from_uspace(void *dst, const void *uspace_src, size_t size)
 {
 	ipl_t ipl;
-	errno_t rc;
+	int rc;
 	
 	assert(THREAD);
@@ -108,10 +108,10 @@
  * @param size Size of the data to be copied.
  *
- * @return 0 on success or an error code from @ref errno.h.
+ * @return 0 on success or error code from @ref errno.h.
  */
-errno_t copy_to_uspace(void *uspace_dst, const void *src, size_t size)
+int copy_to_uspace(void *uspace_dst, const void *src, size_t size)
 {
 	ipl_t ipl;
-	errno_t rc;
+	int rc;
 	
 	assert(THREAD);
Index: kernel/generic/src/sysinfo/stats.c
===================================================================
--- kernel/generic/src/sysinfo/stats.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/sysinfo/stats.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -157,5 +157,5 @@
 	 */
 	
-	if (mutex_trylock(&as->lock) != EOK)
+	if (SYNCH_FAILED(mutex_trylock(&as->lock)))
 		return 0;
 	
@@ -169,5 +169,5 @@
 			as_area_t *area = node->value[i];
 			
-			if (mutex_trylock(&area->lock) != EOK)
+			if (SYNCH_FAILED(mutex_trylock(&area->lock)))
 				continue;
 			
@@ -198,5 +198,5 @@
 	 */
 	
-	if (mutex_trylock(&as->lock) != EOK)
+	if (SYNCH_FAILED(mutex_trylock(&as->lock)))
 		return 0;
 	
@@ -209,5 +209,5 @@
 			as_area_t *area = node->value[i];
 			
-			if (mutex_trylock(&area->lock) != EOK)
+			if (SYNCH_FAILED(mutex_trylock(&area->lock)))
 				continue;
 			
Index: kernel/generic/src/sysinfo/sysinfo.c
===================================================================
--- kernel/generic/src/sysinfo/sysinfo.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/sysinfo/sysinfo.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -61,5 +61,5 @@
  *
  */
-NO_TRACE static errno_t sysinfo_item_constructor(void *obj, unsigned int kmflag)
+NO_TRACE static int sysinfo_item_constructor(void *obj, unsigned int kmflag)
 {
 	sysinfo_item_t *item = (sysinfo_item_t *) obj;
@@ -71,5 +71,5 @@
 	item->next = NULL;
 	
-	return EOK;
+	return 0;
 }
 
@@ -790,8 +790,8 @@
  *
  */
-sys_errno_t sys_sysinfo_get_keys_size(void *path_ptr, size_t path_size,
+sysarg_t sys_sysinfo_get_keys_size(void *path_ptr, size_t path_size,
     void *size_ptr)
 {
-	errno_t rc;
+	int rc;
 	
 	/*
@@ -811,5 +811,5 @@
 		rc = EINVAL;
 	
-	return (sys_errno_t) rc;
+	return (sysarg_t) rc;
 }
 
@@ -838,8 +838,8 @@
  *
  */
-sys_errno_t sys_sysinfo_get_keys(void *path_ptr, size_t path_size,
+sysarg_t sys_sysinfo_get_keys(void *path_ptr, size_t path_size,
     void *buffer_ptr, size_t buffer_size, size_t *size_ptr)
 {
-	errno_t rc;
+	int rc;
 	
 	/* Get the keys */
@@ -858,5 +858,5 @@
 		rc = EINVAL;
 	
-	return (sys_errno_t) rc;
+	return (sysarg_t) rc;
 }
 
@@ -909,8 +909,8 @@
  *
  */
-sys_errno_t sys_sysinfo_get_value(void *path_ptr, size_t path_size,
+sysarg_t sys_sysinfo_get_value(void *path_ptr, size_t path_size,
     void *value_ptr)
 {
-	errno_t rc;
+	int rc;
 	
 	/*
@@ -928,5 +928,5 @@
 		rc = EINVAL;
 	
-	return (sys_errno_t) rc;
+	return (sysarg_t) rc;
 }
 
@@ -945,8 +945,8 @@
  *
  */
-sys_errno_t sys_sysinfo_get_data_size(void *path_ptr, size_t path_size,
+sysarg_t sys_sysinfo_get_data_size(void *path_ptr, size_t path_size,
     void *size_ptr)
 {
-	errno_t rc;
+	int rc;
 	
 	/*
@@ -965,5 +965,5 @@
 		rc = EINVAL;
 	
-	return (sys_errno_t) rc;
+	return (sysarg_t) rc;
 }
 
@@ -995,8 +995,8 @@
  *
  */
-sys_errno_t sys_sysinfo_get_data(void *path_ptr, size_t path_size,
+sysarg_t sys_sysinfo_get_data(void *path_ptr, size_t path_size,
     void *buffer_ptr, size_t buffer_size, size_t *size_ptr)
 {
-	errno_t rc;
+	int rc;
 	
 	/* Get the item */
@@ -1018,5 +1018,5 @@
 		free(ret.data.data);
 	
-	return (sys_errno_t) rc;
+	return (sysarg_t) rc;
 }
 
Index: kernel/generic/src/time/clock.c
===================================================================
--- kernel/generic/src/time/clock.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/time/clock.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -46,5 +46,5 @@
 #include <synch/spinlock.h>
 #include <synch/waitq.h>
-#include <halt.h>
+#include <func.h>
 #include <proc/scheduler.h>
 #include <cpu.h>
Index: kernel/generic/src/time/timeout.c
===================================================================
--- kernel/generic/src/time/timeout.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/time/timeout.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -41,5 +41,5 @@
 #include <panic.h>
 #include <synch/spinlock.h>
-#include <halt.h>
+#include <func.h>
 #include <cpu.h>
 #include <arch/asm.h>
Index: kernel/generic/src/udebug/udebug.c
===================================================================
--- kernel/generic/src/udebug/udebug.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/udebug/udebug.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -98,7 +98,7 @@
 	
 	wq->missed_wakeups = 0;  /* Enforce blocking. */
-	bool blocked;
-	(void) waitq_sleep_timeout_unsafe(wq, SYNCH_NO_TIMEOUT, SYNCH_FLAGS_NONE, &blocked);
-	waitq_sleep_finish(wq, blocked, ipl);
+	int rc = waitq_sleep_timeout_unsafe(wq, SYNCH_NO_TIMEOUT, SYNCH_FLAGS_NONE);
+	
+	waitq_sleep_finish(wq, rc, ipl);
 }
 
@@ -394,8 +394,8 @@
  * @param task Task structure. task->udebug.lock must be already locked.
  *
- * @return Zero on success or an error code.
- *
- */
-errno_t udebug_task_cleanup(struct task *task)
+ * @return Zero on success or negative error code.
+ *
+ */
+int udebug_task_cleanup(struct task *task)
 {
 	assert(mutex_locked(&task->udebug.lock));
Index: kernel/generic/src/udebug/udebug_ipc.c
===================================================================
--- kernel/generic/src/udebug/udebug_ipc.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/udebug/udebug_ipc.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -51,5 +51,5 @@
 #include <udebug/udebug_ipc.h>
 
-errno_t udebug_request_preprocess(call_t *call, phone_t *phone)
+int udebug_request_preprocess(call_t *call, phone_t *phone)
 {
 	switch (IPC_GET_ARG1(call->data)) {
@@ -71,9 +71,8 @@
 static void udebug_receive_begin(call_t *call)
 {
-	errno_t rc;
-	bool active;
-
-	rc = udebug_begin(call, &active);
-	if (rc != EOK) {
+	int rc;
+
+	rc = udebug_begin(call);
+	if (rc < 0) {
 		IPC_SET_RETVAL(call->data, rc);
 		ipc_answer(&TASK->kb.box, call);
@@ -85,6 +84,6 @@
 	 * send a reply.
 	 */
-	if (active) {
-		IPC_SET_RETVAL(call->data, EOK);
+	if (rc != 0) {
+		IPC_SET_RETVAL(call->data, 0);
 		ipc_answer(&TASK->kb.box, call);
 	}
@@ -98,5 +97,5 @@
 static void udebug_receive_end(call_t *call)
 {
-	errno_t rc;
+	int rc;
 
 	rc = udebug_end();
@@ -113,5 +112,5 @@
 static void udebug_receive_set_evmask(call_t *call)
 {
-	errno_t rc;
+	int rc;
 	udebug_evmask_t mask;
 
@@ -132,10 +131,10 @@
 {
 	thread_t *t;
-	errno_t rc;
+	int rc;
 
 	t = (thread_t *)IPC_GET_ARG2(call->data);
 
 	rc = udebug_go(t, call);
-	if (rc != EOK) {
+	if (rc < 0) {
 		IPC_SET_RETVAL(call->data, rc);
 		ipc_answer(&TASK->kb.box, call);
@@ -152,5 +151,5 @@
 {
 	thread_t *t;
-	errno_t rc;
+	int rc;
 
 	t = (thread_t *)IPC_GET_ARG2(call->data);
@@ -172,5 +171,5 @@
 	void *buffer;
 	size_t copied, needed;
-	errno_t rc;
+	int rc;
 
 	uspace_addr = IPC_GET_ARG2(call->data);	/* Destination address */
@@ -182,5 +181,5 @@
 	 */
 	rc = udebug_thread_read(&buffer, buf_size, &copied, &needed);
-	if (rc != EOK) {
+	if (rc < 0) {
 		IPC_SET_RETVAL(call->data, rc);
 		ipc_answer(&TASK->kb.box, call);
@@ -307,5 +306,5 @@
 	thread_t *t;
 	sysarg_t uspace_addr;
-	errno_t rc;
+	int rc;
 	void *buffer;
 
@@ -346,10 +345,10 @@
 	sysarg_t to_copy;
 	void *buffer = NULL;
-	errno_t rc;
+	int rc;
 
 	t = (thread_t *) IPC_GET_ARG2(call->data);
 
 	rc = udebug_regs_read(t, &buffer);
-	if (rc != EOK) {
+	if (rc < 0) {
 		IPC_SET_RETVAL(call->data, rc);
 		ipc_answer(&TASK->kb.box, call);
@@ -390,5 +389,5 @@
 	unsigned size;
 	void *buffer = NULL;
-	errno_t rc;
+	int rc;
 
 	uspace_dst = IPC_GET_ARG2(call->data);
@@ -397,5 +396,5 @@
 
 	rc = udebug_mem_read(uspace_src, size, &buffer);
-	if (rc != EOK) {
+	if (rc < 0) {
 		IPC_SET_RETVAL(call->data, rc);
 		ipc_answer(&TASK->kb.box, call);
Index: kernel/generic/src/udebug/udebug_ops.c
===================================================================
--- kernel/generic/src/udebug/udebug_ops.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/udebug/udebug_ops.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -46,5 +46,4 @@
 #include <errno.h>
 #include <print.h>
-#include <stdbool.h>
 #include <str.h>
 #include <syscall/copy.h>
@@ -79,5 +78,5 @@
  *
  */
-static errno_t _thread_op_begin(thread_t *thread, bool being_go)
+static int _thread_op_begin(thread_t *thread, bool being_go)
 {
 	mutex_lock(&TASK->udebug.lock);
@@ -158,21 +157,18 @@
  *
  * Initiates a debugging session for the current task (and its threads).
- * When the debugging session has started a reply should be sent to the
+ * When the debugging session has started a reply will be sent to the
  * UDEBUG_BEGIN call. This may happen immediately in this function if
  * all the threads in this task are stoppable at the moment and in this
- * case the function sets @a *active to @c true.
- *
- * Otherwise the function sets @a *active to false and the resonse should
- * be sent as soon as all the threads become stoppable (i.e. they can be
- * considered stopped).
+ * case the function returns 1.
+ *
+ * Otherwise the function returns 0 and the reply will be sent as soon as
+ * all the threads become stoppable (i.e. they can be considered stopped).
  *
  * @param call The BEGIN call we are servicing.
- * @param active Place to store @c true iff we went directly to active state,
- *               @c false if we only went to beginning state
- *
- * @return EOK on success, EBUSY if the task is already has an active
- *         debugging session.
- */
-errno_t udebug_begin(call_t *call, bool *active)
+ *
+ * @return 0 (OK, but not done yet), 1 (done) or negative error code.
+ *
+ */
+int udebug_begin(call_t *call)
 {
 	LOG("Debugging task %" PRIu64, TASK->taskid);
@@ -189,10 +185,12 @@
 	TASK->udebug.debugger = call->sender;
 	
+	int reply;
+	
 	if (TASK->udebug.not_stoppable_count == 0) {
 		TASK->udebug.dt_state = UDEBUG_TS_ACTIVE;
 		TASK->udebug.begin_call = NULL;
-		*active = true;  /* directly to active state */
+		reply = 1;  /* immediate reply */
 	} else
-		*active = false;  /* only in beginning state */
+		reply = 0;  /* no reply */
 	
 	/* Set udebug.active on all of the task's userspace threads. */
@@ -209,5 +207,5 @@
 	
 	mutex_unlock(&TASK->udebug.lock);
-	return EOK;
+	return reply;
 }
 
@@ -216,13 +214,13 @@
  * Closes the debugging session for the current task.
  *
- * @return Zero on success or an error code.
- *
- */
-errno_t udebug_end(void)
+ * @return Zero on success or negative error code.
+ *
+ */
+int udebug_end(void)
 {
 	LOG("Task %" PRIu64, TASK->taskid);
 	
 	mutex_lock(&TASK->udebug.lock);
-	errno_t rc = udebug_task_cleanup(TASK);
+	int rc = udebug_task_cleanup(TASK);
 	mutex_unlock(&TASK->udebug.lock);
 	
@@ -236,8 +234,8 @@
  * @param mask Or combination of events that should be enabled.
  *
- * @return Zero on success or an error code.
- *
- */
-errno_t udebug_set_evmask(udebug_evmask_t mask)
+ * @return Zero on success or negative error code.
+ *
+ */
+int udebug_set_evmask(udebug_evmask_t mask)
 {
 	LOG("mask = 0x%x", mask);
@@ -253,5 +251,5 @@
 	mutex_unlock(&TASK->udebug.lock);
 	
-	return EOK;
+	return 0;
 }
 
@@ -266,8 +264,8 @@
  *
  */
-errno_t udebug_go(thread_t *thread, call_t *call)
+int udebug_go(thread_t *thread, call_t *call)
 {
 	/* On success, this will lock thread->udebug.lock. */
-	errno_t rc = _thread_op_begin(thread, false);
+	int rc = _thread_op_begin(thread, false);
 	if (rc != EOK)
 		return rc;
@@ -285,5 +283,5 @@
 	_thread_op_end(thread);
 	
-	return EOK;
+	return 0;
 }
 
@@ -297,5 +295,5 @@
  *
  */
-errno_t udebug_stop(thread_t *thread, call_t *call)
+int udebug_stop(thread_t *thread, call_t *call)
 {
 	LOG("udebug_stop()");
@@ -306,5 +304,5 @@
 	 *
 	 */
-	errno_t rc = _thread_op_begin(thread, true);
+	int rc = _thread_op_begin(thread, true);
 	if (rc != EOK)
 		return rc;
@@ -316,5 +314,5 @@
 		/* Answer will be sent when the thread becomes stoppable. */
 		_thread_op_end(thread);
-		return EOK;
+		return 0;
 	}
 	
@@ -339,5 +337,5 @@
 	mutex_unlock(&TASK->udebug.lock);
 	
-	return EOK;
+	return 0;
 }
 
@@ -364,5 +362,5 @@
  *
  */
-errno_t udebug_thread_read(void **buffer, size_t buf_size, size_t *stored,
+int udebug_thread_read(void **buffer, size_t buf_size, size_t *stored,
     size_t *needed)
 {
@@ -414,5 +412,5 @@
 	*needed = (copied_ids + extra_ids) * sizeof(sysarg_t);
 	
-	return EOK;
+	return 0;
 }
 
@@ -428,5 +426,5 @@
  *
  */
-errno_t udebug_name_read(char **data, size_t *data_size)
+int udebug_name_read(char **data, size_t *data_size)
 {
 	size_t name_size = str_size(TASK->name) + 1;
@@ -437,5 +435,5 @@
 	memcpy(*data, TASK->name, name_size);
 	
-	return EOK;
+	return 0;
 }
 
@@ -457,8 +455,8 @@
  *
  */
-errno_t udebug_args_read(thread_t *thread, void **buffer)
+int udebug_args_read(thread_t *thread, void **buffer)
 {
 	/* On success, this will lock t->udebug.lock. */
-	errno_t rc = _thread_op_begin(thread, false);
+	int rc = _thread_op_begin(thread, false);
 	if (rc != EOK)
 		return rc;
@@ -480,5 +478,5 @@
 	
 	*buffer = arg_buffer;
-	return EOK;
+	return 0;
 }
 
@@ -500,8 +498,8 @@
  *
  */
-errno_t udebug_regs_read(thread_t *thread, void **buffer)
+int udebug_regs_read(thread_t *thread, void **buffer)
 {
 	/* On success, this will lock t->udebug.lock */
-	errno_t rc = _thread_op_begin(thread, false);
+	int rc = _thread_op_begin(thread, false);
 	if (rc != EOK)
 		return rc;
@@ -522,5 +520,5 @@
 	
 	*buffer = (void *) state_buf;
-	return EOK;
+	return 0;
 }
 
@@ -536,5 +534,5 @@
  *
  */
-errno_t udebug_mem_read(sysarg_t uspace_addr, size_t n, void **buffer)
+int udebug_mem_read(sysarg_t uspace_addr, size_t n, void **buffer)
 {
 	/* Verify task state */
@@ -553,12 +551,12 @@
 	 *
 	 */
-	errno_t rc = copy_from_uspace(data_buffer, (void *) uspace_addr, n);
-	mutex_unlock(&TASK->udebug.lock);
-	
-	if (rc != EOK)
+	int rc = copy_from_uspace(data_buffer, (void *) uspace_addr, n);
+	mutex_unlock(&TASK->udebug.lock);
+	
+	if (rc != 0)
 		return rc;
 	
 	*buffer = data_buffer;
-	return EOK;
+	return 0;
 }
 
Index: kernel/test/print/print5.c
===================================================================
--- kernel/test/print/print5.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/test/print/print5.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -37,5 +37,5 @@
  *
  */
-#define _HELENOS_NVERIFY_PRINTF
+#define NVERIFY_PRINTF
 
 #include <print.h>
Index: kernel/test/synch/rcu1.c
===================================================================
--- kernel/test/synch/rcu1.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/test/synch/rcu1.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -51,9 +51,11 @@
 } exited_t;
 
-/* Co-opt EPARTY error code for race detection. */
-#define ERACE   EPARTY
-
-/*-------------------------------------------------------------------*/
-static void wait_for_cb_exit(size_t secs, exited_t *p, errno_t *presult)
+/* Callback raced with preexisting readers. */
+#define ERACE   123
+/* Waited for too long for the callback to exit; consider it lost. */
+#define ECBLOST 432
+
+/*-------------------------------------------------------------------*/
+static void wait_for_cb_exit(size_t secs, exited_t *p, int *presult)
 {
 	size_t loops = 0;
@@ -69,5 +71,5 @@
 	
 	if (!p->exited) {
-		*presult = ETIMEOUT;
+		*presult = ECBLOST;
 	}
 }
@@ -113,8 +115,8 @@
 			bool joined = false;
 			do {
-				errno_t ret = thread_join_timeout(thread[i], 5 * 1000 * 1000, 0);
-				joined = (ret != ETIMEOUT);
+				int ret = thread_join_timeout(thread[i], 5 * 1000 * 1000, 0);
+				joined = (ret != ESYNCH_TIMEOUT);
 				
-				if (ret == EOK) {
+				if (ret == ESYNCH_OK_BLOCKED) {
 					TPRINTF("%zu threads remain\n", thread_cnt - i - 1);
 				}
@@ -365,5 +367,5 @@
 
 
-static errno_t seq_test_result = EOK;
+static int seq_test_result = EOK;
 
 static atomic_t cur_time = {1};
@@ -534,5 +536,5 @@
 	join_one();
 	
-	errno_t result = EOK;
+	int result = EOK;
 	wait_for_cb_exit(2 /* secs */, p, &result);
 	
@@ -553,5 +555,5 @@
 typedef struct preempt_struct {
 	exited_t e;
-	errno_t result;
+	int result;
 } preempt_t;
 
Index: kernel/test/synch/semaphore2.c
===================================================================
--- kernel/test/synch/semaphore2.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/test/synch/semaphore2.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -60,6 +60,5 @@
 static void consumer(void *arg)
 {
-	errno_t rc;
-	int to;
+	int rc, to;
 	
 	thread_detach(THREAD);
@@ -70,5 +69,5 @@
 	TPRINTF("cpu%u, tid %" PRIu64 " down+ (%d)\n", CPU->id, THREAD->tid, to);
 	rc = semaphore_down_timeout(&sem, to);
-	if (rc != EOK) {
+	if (SYNCH_FAILED(rc)) {
 		TPRINTF("cpu%u, tid %" PRIu64 " down!\n", CPU->id, THREAD->tid);
 		return;
Index: release/Makefile
===================================================================
--- release/Makefile	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ release/Makefile	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -83,6 +83,4 @@
 
 release: src_rel
-	mkdir -p $(EXPORT_DIR)/uspace/overlay
-	(cd ..; tools/cc.sh) >$(EXPORT_DIR)/uspace/overlay/COPYRIGHT
 	for profile in $(PROFILES); do \
 		$(MAKE) -r -C $(EXPORT_DIR) distclean ; \
Index: tools/autotool.py
===================================================================
--- tools/autotool.py	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ tools/autotool.py	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -615,5 +615,4 @@
 				path = "%s/%s/bin" % (cross_prefix, platform)
 		
-		common['TARGET'] = target
 		prefix = "%s-" % target
 		
Index: tools/ew.py
===================================================================
--- tools/ew.py	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ tools/ew.py	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -107,5 +107,5 @@
 			raise Exception
 		if processor == 'us':
-			return 'system-sparc64', '-M sun4u --prom-env boot-args="console=devices/\\hw\\pci0\\01:01.0\\com1\\a"'
+			return 'system-sparc64', '-M sun4u --prom-env boot-args="console=devices/\\hw\\pci0\\00:03.0\\com1\\a"'
 		elif processor == 'sun4v':
 			default_path = '/usr/local/opensparc/image/'
@@ -276,6 +276,4 @@
 				'audio' : False,
 				'console' : False,
-                                'net' : False,
-                                'usb' : False
 			},
 			'sun4v' : {
